#include <assert.h>
#include <angelscript.h>
#include "pixel.h"

void PixelRGB(float r, float g, float b, pixel &p)
{
	p.r = r;
	p.g = g;
	p.b = b;
	p.a = 0;
}

void PixelARGB(float a, float r, float g, float b, pixel &p)
{
	p.r = r;
	p.g = g;
	p.b = b;
	p.a = a;
}

void RegisterScriptPixel(asIScriptEngine *engine)
{
	int r;
	r = engine->RegisterObjectType("pixel", 16, asOBJ_CLASS); assert(r >= 0);
	r = engine->RegisterObjectBehaviour("pixel", asBEHAVE_CONSTRUCT, "void f(float, float, float)", asFUNCTION(PixelRGB), asCALL_CDECL_OBJLAST); assert(r >= 0);
	r = engine->RegisterObjectBehaviour("pixel", asBEHAVE_CONSTRUCT, "void f(float, float, float, float)", asFUNCTION(PixelARGB), asCALL_CDECL_OBJLAST); assert(r >= 0);
	r = engine->RegisterObjectProperty("pixel", "float b", 0); assert(r >= 0);
	r = engine->RegisterObjectProperty("pixel", "float g", 4); assert(r >= 0);
	r = engine->RegisterObjectProperty("pixel", "float r", 8); assert(r >= 0);
    r = engine->RegisterObjectProperty("pixel", "float a", 12); assert(r >= 0);
}